
Breed [planktons Plankton]          ; comads to create the breeds and their attributes.
Breed [Sea-turtles Sea-turtle]
Breed [Moons Moon]
Breed [Cassiopeas Cassiopea]

Sea-turtles-own [Energy]
Cassiopeas-own [Energy]
Moons-own [Energy camoed]
  
to setup
  ca
  ask patches [set pcolor 96        ; This creates the differnt sections of the oceans.
    If pycor > 24 [set pcolor 88]
    If pycor < 24 [set pcolor 77]
    If pycor < 16 [set pcolor 76]
    If pycor < 8 [set pcolor 75]
    If pycor < 0  [set pcolor 74]
    If pycor < -8  [set pcolor 73]
    If pycor < -16 [set pcolor 72]
    If pycor < -24 [set pcolor 71]]
End

to plankton-pop                      ; comands to set the turtle's breed, shape, size, and color.
  crt amt-plankton [set Breed Planktons set color 54 set shape "plant" set size 1 
                    setxy random-xcor random-ycor  depth-check depth-check]
End

to Sea-turtle-pop
  crt amt-seaturtles [set Breed Sea-turtles set shape "turtle" set size 4 set color 0 
                      set energy 75 setxy random-xcor random-ycor 
                      If pycor > 24 [depth-check depth-check]]
End

to Moon-pop
  crt amt-Moons [set Breed Moons set color 88 set shape "Jellyfish" set size 3 
                 set energy 75 setxy random-xcor random-ycor 
                 If pycor > 24 or pycor < -16 [depth-check depth-check]]
End
 
to Cassiopea-pop
  crt amt-Cassiopeas [set Breed Cassiopeas set color 35 set shape "Jellyfishmedussa" set size 2 
     set energy 75 setxy random-xcor random-ycor 
     If pycor > 24 or pycor < -16 [depth-check depth-check]]
end
   
To Swim                             ; commands that allow the turtles to move.
  Ask Sea-turtles [ Ifelse ycor < 24 [lt random 30 rt random 30 fd 1][set ycor 23 set heading 180 fd 1] set energy energy - .1 * turtlemetabolism]
  Ask Planktons [Ifelse ycor < 24 and ycor > 8 [lt random 300 rt random 300 fd .5][set ycor 23 set heading 180]]
      Ask Planktons [If ycor < 0 [set heading 0 fd .5]]
  Ask Moons [camo Ifelse ycor <  24 [lt random 90 rt random 60 fd 1][set ycor 23 set heading 180 fd 1] ]
      Ask Moons [If ycor < 5 [ set heading 0  fd 1] set energy energy - .01 * jellymetabolism]
  Ask Cassiopeas [Ifelse ycor < 24 [lt random 40 rt random 40 fd 1][set ycor 23 set heading 180 fd 1] set energy energy - 1]
      Ask Cassiopeas [If ycor < -15 [set heading 0  fd 1] set energy energy - .1 * jellymetabolism]
  Ask turtles [If ycor < -31 [set ycor -30 set heading 0 fd 1]  ]
End

           
to Depth-check                    ; commands that allow the turtles to go specific depths.
  if breed = planktons  [if ycor > 24 [set ycor ycor - 10]    if  ycor < -1 [set ycor ycor + 24]]
  if breed = sea-turtles [if ycor > 24 [set ycor ycor - 10] ]
  if breed = Cassiopeas [if ycor > 24 [set ycor ycor - 10] ]
  if breed = Moons [if ycor > 24 [set ycor ycor - 10] ]
end

 
to feed-repro
    ask planktons [        
        if pycor > 16 [if count planktons < (amt-plankton * 2) [if random 1000 < plankton-reprovalue [hatch 1 ]]]
        if pycor <= 16 [if count planktons < (amt-plankton * 2) [if random 1000 < plankton-reprovalue  [hatch 1]]]]
    ask sea-turtles [ huntjellys if any? turtles-here with [breed = moons ][set energy energy + foodvalue-of-jellyfish]
        if energy <= 0 [die]
        if count sea-turtles < (amt-seaturtles * 2)  [if energy > turtle-reprovalue [ set energy (turtle-reprovalue / 2) hatch 1 [set energy (turtle-reprovalue / 2)  ]]]]
    ask cassiopeas [ if any? turtles-here with [breed = sea-turtles ][die]
        if any? turtles-here with [breed = planktons ][set energy energy + foodvalue-of-plankton]
        if energy <= 0 [die]
        if count cassiopeas < (amt-cassiopeas * 3) [if energy > jellyfish-reprovalue [hatch 1]]]
    ask moons [ if any? turtles-here with [breed = sea-turtles ]  [ifelse camoed = 1 [ if random 100 < 35 [die]] [if random 100 < 75 [die]]]
        if any? turtles-here with [breed = planktons ][set energy energy + foodvalue-of-plankton]
        if energy <= 0 [die]
        if count moons < (amt-moons * 3) [if energy > jellyfish-reprovalue [hatch 1]]]
end
  
     
to huntjellys
   ask sea-turtles [let jellys-seen other turtles with [breed = moons or breed = cassiopeas] in-radius 8
   let closest-jelly min-one-of jellys-seen [distance myself]
   if closest-jelly != nobody [face closest-jelly ]]
end


To Camo                            ; commands that allow the turtles to match the patch color they are in.
  Ask Moons [ Ifelse any? turtles in-cone 8 360 with [breed = Sea-turtles] [set color (pcolor - 1) set camoed 1] [set color 88 set camoed 0]]
End
   
@#$#@#$#@
GRAPHICS-WINDOW
210
10
740
561
32
32
8.0
1
10
1
1
1
0
1
0
1
-32
32
-32
32
0
0
1
ticks

CC-WINDOW
5
622
1219
717
Command Center
0

BUTTON
87
75
151
108
NIL
Setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
69
167
173
200
NIL
Plankton-pop
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
68
219
180
252
NIL
Sea-turtle-pop
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
76
260
172
293
NIL
Moon-pop
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
71
298
190
331
NIL
Cassiopea-pop
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
91
482
154
515
NIL
Swim
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

MONITOR
948
16
1051
61
NIL
Count Planktons
17
1
11

MONITOR
949
237
1053
282
NIL
Count Sea-turtles
17
1
11

MONITOR
946
88
1050
133
NIL
Count Moons
17
1
11

MONITOR
949
161
1055
206
NIL
Count Cassiopeas
17
1
11

SLIDER
753
15
925
48
amt-plankton
amt-plankton
0
400
30
10
1
NIL
HORIZONTAL

SLIDER
759
235
931
268
amt-seaturtles
amt-seaturtles
0
10
4
1
1
NIL
HORIZONTAL

SLIDER
754
88
926
121
amt-Moons
amt-Moons
0
25
10
1
1
NIL
HORIZONTAL

SLIDER
757
159
929
192
amt-Cassiopeas
amt-Cassiopeas
0
25
10
1
1
NIL
HORIZONTAL

BUTTON
78
428
170
461
NIL
feed-repro
T
1
T
TURTLE
NIL
NIL
NIL
NIL

SLIDER
763
432
935
465
plankton-reprovalue
plankton-reprovalue
0
100
10
1
1
NIL
HORIZONTAL

SLIDER
763
468
935
501
turtle-reprovalue
turtle-reprovalue
0
500
232
1
1
NIL
HORIZONTAL

SLIDER
767
521
939
554
jellyfish-reprovalue
jellyfish-reprovalue
0
500
245
1
1
NIL
HORIZONTAL

MONITOR
1070
87
1194
132
Avg Moon's Energy
(sum  [energy] of Moons / count moons)
17
1
11

MONITOR
1072
159
1198
204
Avg Cassiopea's Energy
(sum  [energy] of Cassiopeas / count cassiopeas)
17
1
11

MONITOR
1074
234
1210
279
Avg Sea-turtle Energy
(sum  [energy] of sea-turtles / count sea-turtles)
17
1
11

SLIDER
1023
436
1196
469
foodvalue-of-plankton
foodvalue-of-plankton
0
500
38
1
1
NIL
HORIZONTAL

SLIDER
1025
479
1197
512
foodvalue-of-jellyfish
foodvalue-of-jellyfish
0
100
93
1
1
NIL
HORIZONTAL

SLIDER
763
314
935
347
turtlemetabolism
turtlemetabolism
0
100
12
1
1
NIL
HORIZONTAL

SLIDER
764
352
936
385
jellymetabolism
jellymetabolism
0
100
15
1
1
NIL
HORIZONTAL

BUTTON
462
575
525
608
clear
ca
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

@#$#@#$#@
## ## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## ## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## ## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## ## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## ## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## ## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## ## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## ## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## ## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

jellyfish
false
0
Line -7500403 true 105 182 75 285
Line -7500403 true 115 187 120 285
Line -7500403 true 143 188 150 285
Line -7500403 true 187 184 165 285
Line -7500403 true 200 173 225 270
Line -7500403 true 93 177 45 270
Line -7500403 true 105 180 90 300
Line -7500403 true 165 195 180 285
Line -7500403 true 202 172 202 292
Line -7500403 true 135 195 135 300
Line -7500403 true 82 164 60 285
Line -7500403 true 180 180 195 270
Circle -7500403 true true 70 55 144
Circle -7500403 true true 142 142 16
Rectangle -7500403 true true 169 143 187 164
Rectangle -7500403 true true 117 155 192 178
Circle -7500403 false true 126 117 38
Circle -7500403 false true 131 116 34

jellyfishmedussa
false
0
Line -7500403 true 195 118 225 15
Line -7500403 true 185 113 180 15
Line -7500403 true 157 112 150 15
Line -7500403 true 113 116 135 15
Line -7500403 true 100 127 75 30
Line -7500403 true 207 123 255 30
Line -7500403 true 195 120 210 0
Line -7500403 true 135 105 120 15
Line -7500403 true 98 128 98 8
Line -7500403 true 165 105 165 0
Line -7500403 true 218 136 240 15
Line -7500403 true 120 120 105 30
Circle -7500403 true true 86 41 144
Circle -7500403 true true 142 142 16
Rectangle -7500403 true true 113 136 131 157
Rectangle -7500403 true true 108 122 183 145
Circle -7500403 false true 136 145 38
Circle -7500403 false true 134 149 35

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -16777216 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -16777216 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -16777216 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -16777216 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -16777216 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -13345367 true false 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.0.5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="OceanTest" repetitions="1" runMetricsEveryStep="true">
    <setup>setup
Plankton-pop
Sea-turtle-pop
Moon-pop
Cassiopea-pop</setup>
    <go>go</go>
    <exitCondition>if count moons &lt; 1</exitCondition>
    <metric>count Moons</metric>
    <enumeratedValueSet variable="turtle-reprovalue">
      <value value="232"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="plankton-reprovalue">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="foodvalue-of-jellyfish">
      <value value="93"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="jellymetabolism">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="foodvalue-of-plankton">
      <value value="38"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amt-Moons">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="jellyfish-reprovalue">
      <value value="245"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amt-seaturtles">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amt-plankton">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="turtlemetabolism">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amt-Cassiopeas">
      <value value="10"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
